<?php
////////////////////////////////////////////////////////////////////////////////////
// Copyright 2009 SYSTECMX.COM  All Rights Reserved.                              //
////////////////////////////////////////////////////////////////////////////////////
include_once('../include/base.admin.php');
include_once(INCLUDE_DIR.'pagination.class.php');
if(!$is_logged || !$is_admin)
  redir('..');

$uid  = isset($_GET['uid']) ? intval($_GET['uid']) : intval($_POST['uid']);
$user = $db->get_result("SELECT * FROM tbl0 WHERE `uid`='{$uid}' LIMIT 1", 'users');
$l             = $tpl->get_section('messages.conf', 'admin_levels');
$level_options = array( 0 => $l['user'], 255 => $l['admin']);

if($_POST['btn_save'])
{
  $tpl->config_load('messages.conf', 'admin_user_page');
  $username = strtolower(trim($_POST['username']));
  $password = trim($_POST['password']);
  // empty fields ?
  if(empty($username) || empty($password))
    $error = $tpl->get_config_vars('err_empty');
  // check if username is taken
  else if($db->get_total('users', "`username`='{$username}' AND `uid`<>'{$uid}'")>0)
    $error = $tpl->get_config_vars('err_taken');
  // modify fields
  else
  {
    if($username != $user['username']) $f['username'] = $username;
    if($password != password2str($user['password'])) $f['password'] = $password;
    if($_POST['email'] != $user['email']) $f['email'] = trim($_POST['email']);
    if($_POST['level'] != $user['level']) $f['level'] = intval($_POST['level']);
    if($_POST['confirmed'] != $user['confirmed']) $f['confirmed'] = intval($_POST['confirmed']);
    if($_POST['twitter_username'] != $user['twitter_username']) $f['twitter_username'] = $_POST['twitter_username'];
    if($_POST['twitter_password'] != password2str($user['twitter_password'])) $f['twitter_password'] = $_POST['twitter_password'];
    if($_POST['enabled'] != $user['enabled']) $f['enabled'] = intval($_POST['enabled']);
    if($_POST[''] != $user['']) $f[''] = $_POST[''];
    $sql = '';
    if(is_array($f))
    {
      foreach($f as $name => $value)
        $sql .= "`{$name}`='{$value}',";
      $sql = substr($sql, 0, strlen($sql)-1);
      $db->query("UPDATE tbl0 SET $sql WHERE `uid`='{$uid}' LIMIT 1",'users');
    }
  }
  if(isset($error))
  {
    $tpl->assign('error', $error);
    $_GET['a'] = 'edit';
  }
}

if($_GET['a']=='delete')
{
  $db->query("DELETE FROM tbl0 WHERE `uid`='{$uid}' LIMIT 1", 'users');
  $db->query("DELETE FROM tbl0 WHERE `uid`='{$uid}' LIMIT 1", 'register');
}
elseif($_GET['a']=='edit')
{
  $user['password']         = password2str($user['password']);
  $user['twitter_password'] = password2str($user['twitter_password']);
  $tpl->assign($user);
  $yn            = $tpl->get_section('messages.conf', 'options_yesno');
  $yesno_options = array( 0 => $yn['op_false'], 1 => $yn['op_true']);

  $tpl->assign('level_options',      $level_options);
  $tpl->assign('confirmed_options',  $yesno_options);
  $tpl->assign('enabled_options',    $yesno_options);
  $tpl->config_load('messages.conf', 'admin_user_page');
  $tpl->assign('main_area',          'admin.user.tpl');
}
else
{
  $s = intval($_GET['s']);
  if($s==0) $sort = 'username';
  elseif($s==1) $sort = 'twitter_username';
  elseif($s==2) $sort = 'email';
  elseif($s==3) $sort = 'level';
  elseif($s==4) $sort = 'count';
  elseif($s==5) $sort = 'enabled';
  else $sort = 'confirmed';
  $sql = $db->get_sql("SELECT * FROM tbl0 ORDER BY `{$sort}` ASC", 'users');
  $p = new Pagination($sql, $settings['max_users_per_page']);
  $users = $p->getArray();
  for($i=0; $i<count($users); $i++)
  {
    $users[$i]['confirmed'] = $users[$i]['confirmed'] == '1' ? 'Yes' : 'No';
    $users[$i]['enabled']   = $users[$i]['enabled'] == '1' ? 'Yes' : 'No';
    $users[$i]['level']     = $level_options[$users[$i]['level']];
  }
  $tpl->assign('users',      $users);
  $tpl->assign('pagination', $p->displayPaging("s=$s"));
  $tpl->assign($p->pagename, $_GET[$p->pagename]);
  $tpl->config_load('messages.conf','admin_users_page');
  $tpl->assign('main_area',  'admin.users.tpl');
}
$tpl->assign('menus', $tpl->get_menu('messages.conf','menu_admin'));
$tpl->display('admin.index.tpl');
?>