<?php
////////////////////////////////////////////////////////////////////////////////////
// Copyright 2009 SYSTECMX.COM  All Rights Reserved.                              //
////////////////////////////////////////////////////////////////////////////////////
set_time_limit(0);
include_once('../config.php');
include_once('database.class.php');

//---------------------------------------------------------------------------------
function get_settings()
{
  global $db;
  $result = array();
  $array  = $db->get_results('SELECT * FROM tbl0 ORDER BY `name`;','settings');
  foreach($array as $item)
    $result[$item['name']] = $item['value'];
  return($result);
}

//---------------------------------------------------------------------------------
function replace_tags($text, $array)
{
  if(is_array($array))
    foreach($array as $name=>$value)
      $text = str_ireplace("[{$name}]", $value, $text);
  return($text);
}

//---------------------------------------------------------------------------------
$db        = new MySQL();
$settings  = get_settings();
$emails    = $db->get_results("SELECT `username`,`password`,`email` FROM tbl0 WHERE `confirmed`='1'",'users');
$total     = $db->get_total('messages');
if($total != 0)
{
    $mail      = $db->get_result("SELECT * FROM tbl0 LIMIT 1;",'emails');
    $a = array(
                'webmaster'        => $settings['site_webmaster_name'].'<'.$settings['site_webmaster_email'].'>',
                'site_url'         => $settings['site_url'],
                'site_name'        => $settings['site_name']
               );
    $headers = replace_tags("From: [webmaster]\r\nReply-To: [webmaster]\r\n", $a);
    $mail['subject'] = replace_tags($mail['subject'], $a);
    $mail['body']    = replace_tags($mail['body'],    $a);
    for($i=0; $i<count($emails); $i++)
    {
      if(!empty($emails[$i]['email']))
      {
        $a = array(
                    'username'         => $emails[$i]['username'],
                    'password'         => $emails[$i]['password'],
                    'email'            => $emails[$i]['email']
                   );
        $tmp_subject = replace_tags($mail['subject'], $a);
        $tmp_body    = replace_tags($mail['body'], $a);
        @mail($emails[$i]['email'], $tmp_subject, $tmp_body, $headers);
      }
    }

    $db->query("DELETE FROM tbl0 WHERE `eid`='{$mail['eid']}'", 'emails');
}
?>