<?php
////////////////////////////////////////////////////////////////////////////////////
// Copyright 2007 SYSTECMX.  All Rights Reserved.                                 //
// Pagination Class                                                               //
//                                                                                //
// - Fixed error with empty list (page/0)                                         //
////////////////////////////////////////////////////////////////////////////////////
class Pagination
{
  var $text = array (
                     'first'    => '|<',
                     'previous' => '<',
                     'next'     => '>',
                     'last'     => '>|'
                    );
	var $fullresult;
	var $totalresult;
	var $query;
	var $resultPerPage;
	var $pages;
	var $openPage;
  var $pagename;
  var $db;

/*
@param - User query
@param - Total number of result per page
*/
	function Pagination($sql, $resultPerPage, $smartyobj= null, $pagename='page')
	{
    $this->pagename = $pagename;
    if(!is_null($smartyobj))
    {
      $this->text['first']    = $smartyobj->get_config_vars('first');
      $this->text['previous'] = $smartyobj->get_config_vars('previous');
      $this->text['next']     = $smartyobj->get_config_vars('next');
      $this->text['last']     = $smartyobj->get_config_vars('last');
    }
		$this->resultPerPage  = $resultPerPage;
		$this->fullresult	    = @mysql_query($sql);
		$this->totalresult	  = @mysql_num_rows($this->fullresult);
		$this->pages		      = $this->findPages($this->totalresult,$this->resultPerPage);

		if(isset($_GET[$this->pagename]) && $_GET[$this->pagename]>0)
    {
			$this->openPage	=	$_GET[$this->pagename];
			if($this->openPage > $this->pages)
				$this->openPage	=	1;
			$start	=	$this->openPage * $this->resultPerPage - $this->resultPerPage;
			$end	  =	$this->resultPerPage;
			$sql   .=	" LIMIT $start,$end;";
		}
		else if($_GET[$this->pagename]>$this->pages)
    {
			$start =	$this->pages;
			$end   =	$this->resultPerPage;
			$sql  .=	" LIMIT $start,$end;";
		}
		else
    {
			$this->openPage	=	1;
			$sql .=	" LIMIT 0,{$this->resultPerPage};";
		}
		$this->query =	@mysql_query($sql);
	}

  function getArray()
  {
    $result = array();
    while ($r = @mysql_fetch_assoc($this->query))
    {
      $result[] = $r;
    }
    @mysql_free_result($this->query);
    return($result);
  }

/*
function to calculate the total number of pages required
@param - Total number of records available
@param - Result per page
*/
	function findPages($total,$perpage)
	{
    if(empty($total) || empty($perpage))
      $pages = 0;
    else
    {
		  $pages	=	intval($total/$perpage);
		  if($total%$perpage > 0)
        $pages++;
    }
		return $pages;
	}

/*
function to display the pagination
*/
	function displayPaging($params='')
	{
    $result = "";
    $pos  = strlen(SETUP_DIR) + (ADMIN_AREA ? 6 : 0);
    $self = substr($_SERVER['SCRIPT_FILENAME'], $pos);
		if($this->openPage<=0)
			$next	=	2;
		else
			$next	=	$this->openPage+1;
    $p      = !empty($params) ? "&$params" : '';
		$prev	  =	$this->openPage-1;
		$last	  =	$this->pages;
    $result = $this->openPage > 1 ? "<a href='$self?{$this->pagename}=1{$p}'>{$this->text['first']}</a>&nbsp&nbsp;".
                                    "<a href='$self?{$this->pagename}=$prev{$p}'>{$this->text['previous']}</a>&nbsp&nbsp;"
                                  : "{$this->text['first']}&nbsp&nbsp;{$this->text['previous']}&nbsp&nbsp;";
		for($i=1;$i<=$this->pages;$i++)
      $result .= ($i == $this->openPage) ? "$i&nbsp&nbsp;" : "<a href='$self?{$this->pagename}=$i{$p}'>$i</a>&nbsp&nbsp;";
		if($this->openPage < $this->pages)
      $result .= "<a href='$self?{$this->pagename}=$next{$p}'>{$this->text['next']}</a>&nbsp&nbsp;".
                 "<a href='$self?{$this->pagename}=$last{$p}'>{$this->text['last']}</a>&nbsp&nbsp;";
		else
      $result .= "{$this->text['next']}&nbsp&nbsp;{$this->text['last']}&nbsp&nbsp;";
    return($result);
	}
}
?>