<?php
////////////////////////////////////////////////////////////////////////////////////
// Copyright 2009 SYSTECMX.COM  All Rights Reserved.                              //
//      Name : Twitter Core                                                       //
//   Version : 1.0                                                                //
////////////////////////////////////////////////////////////////////////////////////
class Twitter
{
  // curl variables
  var $ch;
  var $debug;
  var $username;
  var $password;

  // ---------------------------------------------------------------------------------------
  // - CURL Functions                                                                      -
  // ---------------------------------------------------------------------------------------
  function __httpPost($url, $data, $timeout = 10)
  {
    // CURL initialization
    $this->ch = curl_init();
    curl_setopt($this->ch, CURLOPT_FAILONERROR,    true);
    curl_setopt($this->ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($this->ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($this->ch, CURLOPT_USERPWD,        "{$this->username}:{$this->password}");
    curl_setopt($this->ch, CURLOPT_URL,            $url);
    curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($this->ch, CURLOPT_TIMEOUT,        $timeout);
    curl_setopt($this->ch, CURLOPT_POST,           1);
    if(is_array($data))
    {
      $post_array = array();
      foreach($data as $key=>$value)
        $post_array[] = urlencode($key) . '=' . urlencode($value);
      $data = implode("&", $post_array);
      if($this->debug)
        echo "CURL Post - $url [$data]\n";
    }
    curl_setopt($this->ch, CURLOPT_POSTFIELDS, $data);
    $result = curl_exec($this->ch);

    if(curl_errno($this->ch))
    {
      if($this->debug)
        printf("CURL Error (%d) : %s\n", curl_errno($this->ch), curl_error($this->ch));
      $result = false;
    };
    curl_close($this->ch);
    return($result);
  }

  // ---------------------------------------------------------------------------------------
  // - CLASS Functions                                                                     -
  // ---------------------------------------------------------------------------------------
  function Twitter()
  {
    $this->debug = false;
  }

  function Status($status)
  {
    $result = false;
    if(strlen($status)>140)
      $status = substr($status,0,140);
    return($this->__httpPost('http://twitter.com/statuses/update.json', array("status"=>$status)));
  }

}
?>