<?php
////////////////////////////////////////////////////////////////////////////////////
// Copyright 2009 SYSTECMX.COM  All Rights Reserved.                              //
////////////////////////////////////////////////////////////////////////////////////
session_start();
session_register('config');

ob_start('ob_gzhandler');
define('SETUP_DIR', str_replace('\\','/', getcwd().'/'));
include_once(SETUP_DIR.'include/tpl.class.php');

function p2n($text)
{
  return(str_replace('\r\n', "\r\n", $text));
}

if(isset($_GET['step']))
  $step = intval($_GET['step'])-1;
else
  $step = empty($_SESSION['config']['step']) ? 1 : intval($_SESSION['config']['step']);

$tpl  = new Template(SETUP_DIR.'templates');
$tpl->config_load('install.conf',"buttons");

if($step == 1)
{
  $tpl->config_load('install.conf',"step_1");
  if($_POST['step'])
  {
    $_SESSION['config']['db']['db_server']   = $_POST['db_server'];
    $_SESSION['config']['db']['db_database'] = $_POST['db_database'];
    $_SESSION['config']['db']['db_username'] = $_POST['db_username'];
    $_SESSION['config']['db']['db_password'] = $_POST['db_password'];
    $_SESSION['config']['db']['db_prefix']   = $_POST['db_prefix'];
    $step++;
    unset($_POST['step']);
  }
  else
    $tpl->assign('main_area', 'install.step1.tpl');
  $tpl->assign($_SESSION['config']['db']);
}

if($step == 2)
{
  $tpl->config_load('install.conf',"step_2");
  if($_POST['step'])
  {
    $site_url = trim($_POST['site_url']);
    if(substr($site_url,strlen($site_url)-1,1) != '/') $site_url .= '/';
    $_SESSION['config']['site']['site_name']              = trim($_POST['site_name']);
    $_SESSION['config']['site']['site_url']               = $site_url;
    $_SESSION['config']['site']['site_webmaster_name']    = trim($_POST['site_webmaster_name']);
    $_SESSION['config']['site']['site_webmaster_email']   = trim($_POST['site_webmaster_email']);
    $_SESSION['config']['site']['site_allow_register']    = intval($_POST['site_allow_register']);
    $_SESSION['config']['site']['site_show_twitter_link'] = intval($_POST['site_show_twitter_link']);
    $_SESSION['config']['site']['max_users_per_page']     = intval($_POST['max_users_per_page']);
    $_SESSION['config']['site']['max_msgs_per_page']      = intval($_POST['max_msgs_per_page']);
    $_SESSION['config']['site']['max_msgs_per_hour']      = intval($_POST['max_msgs_per_hour']);
    $_SESSION['config']['site']['max_days_to_delete']     = intval($_POST['max_days_to_delete']);
    $step++;
    unset($_POST['step']);
  }
  $tpl->assign('main_area', 'install.step2.tpl');
  $tpl->assign($_SESSION['config']['site']);
}

if($step == 3)
{
  $tpl->config_load('install.conf',"step_3");
  if($_POST['step'])
  {
    // generate config.php
    $tpl->assign($_SESSION['config']['db']);
    if(@file_put_contents(SETUP_DIR.'config.php', $tpl->fetch('config.tpl'))==0)
    {
      $tpl->assign('error', 'Error writing <b>config.php</b> file');
    }
    else
    {
        // try to connect to the database
        if(!$link = @mysql_connect($_SESSION['config']['db']['db_server'], $_SESSION['config']['db']['db_username'], $_SESSION['config']['db']['db_password']))
          $tpl->assign('error', 'Could not connect: ' . mysql_error());
        else if(!@mysql_select_db($_SESSION['config']['db']['db_database'], $link))
          $tpl->assign('error', 'Can not use database : ' . mysql_error());
        else
        {
          // generate tables
          $sql = file_get_contents(SETUP_DIR.'mysql/database.sql');
          $sql = explode(';', $sql);
          for($i=0; $i < count($sql); $i++)
            @mysql_query(str_replace('{db_prefix}',$_SESSION['config']['db']['db_prefix'],$sql[$i]));
          // generate site settings
          $q = '';
          foreach($_SESSION['config']['site'] as $name => $value)
            $q .= "('{$name}', '{$value}'),";
          $q = str_replace('{db_prefix}',$_SESSION['config']['db']['db_prefix'],"INSERT INTO `{db_prefix}settings` (`name`, `value`) VALUES ".substr($q,0,strlen($q)-1).";");
          @mysql_query($q);
          // generate email settings
          $q = '';
          foreach($_SESSION['config']['mail'] as $name => $value)
            $q .= "('{$name}', '{$value}'),";
          $q = str_replace('{db_prefix}',$_SESSION['config']['db']['db_prefix'],"INSERT INTO `{db_prefix}settings` (`name`, `value`) VALUES ".substr($q,0,strlen($q)-1).";");
          @mysql_query($q);

          unset($_POST['step']);
          $step++;
        }
      }
  }
  if(empty($_SESSION['config']['mail']['email_signup_subject']))    $_SESSION['config']['mail']['email_signup_subject']    = p2n($tpl->get_config_vars('msg_email_signup_subject'));
  if(empty($_SESSION['config']['mail']['email_signup_body']))       $_SESSION['config']['mail']['email_signup_body']       = p2n($tpl->get_config_vars('msg_email_signup_body'));
  if(empty($_SESSION['config']['mail']['email_confirmed_subject'])) $_SESSION['config']['mail']['email_confirmed_subject'] = p2n($tpl->get_config_vars('msg_email_confirmed_subject'));
  if(empty($_SESSION['config']['mail']['email_confirmed_body']))    $_SESSION['config']['mail']['email_confirmed_body']    = p2n($tpl->get_config_vars('msg_email_confirmed_body'));
  if(empty($_SESSION['config']['mail']['email_forgot_subject']))    $_SESSION['config']['mail']['email_forgot_subject']    = p2n($tpl->get_config_vars('msg_email_forgot_subject'));
  if(empty($_SESSION['config']['mail']['email_forgot_body']))       $_SESSION['config']['mail']['email_forgot_body']       = p2n($tpl->get_config_vars('msg_email_forgot_body'));
  $tpl->assign('main_area', 'install.step3.tpl');
  $tpl->assign($_SESSION['config']['mail']);
}

if($step == 4)
{
  $tpl->config_load('install.conf',"step_4");
  $tpl->assign('main_area', 'install.step4.tpl');
  session_unset();
  session_unregister('config');
  unset($_SESSION['config']);
  session_destroy();
}

$_SESSION['config']['step'] = $step;
$tpl->assign('yesno_options', array(0=>'No', 1=>'Yes' ));
$tpl->assign('step', $step);
$tpl->display('install.index.tpl');
?>