<?php
////////////////////////////////////////////////////////////////////////////////////
// Copyright 2009 SYSTECMX.COM  All Rights Reserved.                              //
////////////////////////////////////////////////////////////////////////////////////
set_time_limit(0);
include_once('../config.php');
include_once('database.class.php');
include_once('twitter.class.php');

//---------------------------------------------------------------------------------
function get_status($text)
{
  return(@preg_match('%"id":[0-9]+,%i', $text) ? 'P' : 'E');
}
//---------------------------------------------------------------------------------
function set_setting($name, $value)
{
  global $db;
  $name = strtolower($name);
  if($db->get_total('settings',"`name`='{$name}'") == 0)
    $db->query("INSERT INTO tbl0 (`name`, `value`) VALUES ('{$name}', '{$value}')", 'settings');
  else
    $db->query("UPDATE tbl0 SET `value`='{$value}' WHERE `name`='{$name}'", 'settings');
}
//---------------------------------------------------------------------------------
function update_counters()
{
  global $db;
  set_setting('count_queued', $db->get_total('messages',"`status`='Q'"));
  set_setting('count_posted', $db->get_total('messages',"`status`='P'"));
  set_setting('count_users',  $db->get_total('users'));
  $users = $db->get_results("SELECT `uid` FROM tbl0", 'users');
  foreach($users as $uid)
  {
    $r = $db->get_result("SELECT SUM(`count`) AS total FROM tbl0 WHERE `uid`='{$uid['uid']}'", 'messages');
    if(!is_null($r['total']))
      $db->query("UPDATE tbl0 SET `count`='{$r['total']}' WHERE `uid`='{$uid['uid']}' LIMIT 1", 'users');
  }
}
//---------------------------------------------------------------------------------
$db = new MySQL();
$twitter = new Twitter();
// No re-ocurrance
$sql = "SELECT m.*, u.`twitter_username`, u.`twitter_password` ".
       "FROM tbl0 AS m, tbl1 AS u ".
       "WHERE (`datetime` < NOW()) AND (m.`uid`=u.`uid`) AND (m.`type`='N') AND (m.`status`='Q') ORDER BY `datetime`";
$items = $db->get_results($sql,'messages,users');
foreach($items  as $item)
{
  $twitter->username = $item['twitter_username'];
  $twitter->password = $item['twitter_password'];
  $text   = $twitter->Status($item['message']);
  $sql    = "UPDATE tbl0 SET `status`='".get_status($text)."', `count`=`count`+1, `posttime`=NOW() ".
            "WHERE `mid`='{$item['mid']}' LIMIT 1";
  $db->query($sql,'messages');
}

// Reccurrent Post
$sql = "SELECT m.*, u.`twitter_username`, u.`twitter_password` ".
       "FROM tbl0 AS m, tbl1 AS u ".
       "WHERE (`datetime` < NOW()) AND (m.`uid`=u.`uid`) AND (m.`type`<>'N')";
$items = $db->get_results($sql,'messages,users');
foreach($items  as $item)
{
  $twitter->username = $item['twitter_username'];
  $twitter->password = $item['twitter_password'];
  switch ($item['type'])
  {
    case 'D' : // Daily
               $next = "1 DAY";
               break;
    case 'W' : // Weekly
               $next = "1 WEEK";
               break;
    case 'M' : // Montly
               $next = "1 MONTH";
               break;
    case 'Y' : // Yearly
               $next = "1 YEAR";
               break;
  }
  $text   = $twitter->Status($item['message']);
  $status = (get_status($text)=='E') ? "`status`='E', " : '';
  $sql    = "UPDATE tbl0 SET $status `count`=`count`+1, `datetime`=DATE_ADD(datetime,INTERVAL $next), `posttime`=NOW() ".
            "WHERE `mid`='{$item['mid']}' LIMIT 1";
  $db->query($sql,'messages');
}

unset($twitter);

// delete old post
$days = $db->get_result("SELECT `value` FROM tbl0 WHERE `name`='max_days_to_delete' LIMIT 1",'settings');
$sql  = "DELETE FROM tbl0 WHERE `datetime`<DATE_SUB(NOW(), INTERVAL {$days['value']} DAY)";
$db->query($sql,'messages');
update_counters();
?>