<?php
////////////////////////////////////////////////////////////////////////////////////
// Copyright 2009 SYSTECMX.COM  All Rights Reserved.                              //
////////////////////////////////////////////////////////////////////////////////////
include_once('smarty/Smarty.class.php');
class Template extends Smarty
{
  function Template($path)
  {
    $path = (substr($path,strlen($path)-1,1) == '/') ? $path : $path.'/';
    $this->template_dir = $path;
    $this->compile_dir  = $path.'templates_c';
    $this->cache_dir    = $path.'cache';
    $this->config_dir   = $path.'configs';
    $this->register_modifier('number','number_format');
  }

  function get_menu($filename, $section)
  {
    global $is_admin, $is_logged;
    $result = array();
    $tmp = $this->_config;
    $this->clear_config();
    $this->config_load($filename, $section);
    $items = $this->_config[0]['vars'];
    $this->clear_config();
    $this->_config = $tmp;
    if(is_array($items))
      foreach($items as $item)
      {
        $menu = explode('|', $item);
        if(is_null($menu[2]))
          $result[$menu[1]] = $menu[0];
        elseif(($menu[2] == '1') && $is_logged)
          $result[$menu[1]] = $menu[0];
        elseif(($menu[2] == '2') && $is_admin)
          $result[$menu[1]] = $menu[0];
      }
    return($result);
  }

  function get_section($filename, $section='')
  {
    $tmp = $this->_config;
    $this->clear_config();
    $this->config_load($filename, $section);
    $result = $this->_config[0]['vars'];
    $this->clear_config();
    $this->_config = $tmp;
    return($result);
  }
}
?>