CREATE TABLE `{db_prefix}messages` (
  `mid` int(10) unsigned NOT NULL auto_increment,
  `uid` int(10) unsigned NOT NULL,
  `message` varchar(140) NOT NULL,
  `datetime` datetime NOT NULL,
  `status` enum('Q','P','E') NOT NULL default 'Q',
  `type` enum('N','D','W','M','Y') NOT NULL default 'N',
  `posttime` datetime NOT NULL default '0000-00-00 00:00:00',
  `count` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`mid`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1;
CREATE TABLE `{db_prefix}register` (
  `uid` int(10) unsigned NOT NULL,
  `code` varchar(32) NOT NULL,
  `date` datetime NOT NULL,
  PRIMARY KEY  (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
CREATE TABLE `{db_prefix}settings` (
  `name` varchar(50) NOT NULL,
  `value` text NOT NULL,
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
INSERT INTO `{db_prefix}settings` (`name`, `value`) VALUES
('count_deleted', '0'),
('count_posted', '0'),
('count_queued', '0'),
('count_users', '0');
CREATE TABLE `{db_prefix}users` (
  `uid` int(10) unsigned NOT NULL auto_increment,
  `username` varchar(32) NOT NULL,
  `password` varchar(32) NOT NULL,
  `email` varchar(60) NOT NULL,
  `level` tinyint(3) unsigned NOT NULL default '0',
  `confirmed` tinyint(3) unsigned NOT NULL default '0',
  `twitter_username` varchar(15) default '',
  `twitter_password` varchar(20) default '',
  `enabled` tinyint(3) unsigned default '0',
  `count` int(10) unsigned default '0',
  PRIMARY KEY  (`uid`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1;
INSERT INTO `{db_prefix}users` (`uid`, `username`, `password`, `email`, `level`, `confirmed`, `twitter_username`, `twitter_password`, `enabled`, `count`) VALUES
(1, 'admin', 'admin', '', 255, 1, '', '', 0, 0);
CREATE TABLE IF NOT EXISTS `{db_prefix}emails` (
  `eid` int(10) unsigned NOT NULL auto_increment,
  `subject` text NOT NULL,
  `body` text NOT NULL,
  PRIMARY KEY  (`eid`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1;