<?php
////////////////////////////////////////////////////////////////////////////////////
// Copyright 2009 SYSTECMX.COM  All Rights Reserved.                              //
////////////////////////////////////////////////////////////////////////////////////
include_once('include/base.php');

if(!$is_logged)
  redir('index.php');

// check if messages < max_msgs_per_hour
if(isset($_POST['datetime']))
{
  get_time_limit($_POST['datetime'],$d1, $d2);
  $count = $db->get_total('messages',"`datetime` BETWEEN '{$d1}' AND '{$d2}'");
}
else
  $count = 0;

$tpl->config_load('messages.conf','schedule_page');

$icons = $tpl->get_section('ascii.conf');
$tpl->config_load('messages.conf','schedule_options');
$a = !empty($_GET['a']) ? $_GET['a'] : (!empty($_POST['a']) ? $_POST['a'] : 'add');
if($a=='delete')
{
  $mid = intval($_GET['mid']);
  $sql = "DELETE FROM tbl0 WHERE (`mid`='{$mid}') AND (`uid`='{$_SESSION[SESSION_NAME]['uid']}') LIMIT 1";
  $db->query($sql, 'messages');
  $db->query("UPDATE tbl0 SET `value`=`value`+1 WHERE `name`='count_deleted'",'settings');
  redir('index.php');
}
else if(($a == 'add') && $_POST['btn_schedule'])
{
  if($count < $settings['max_msgs_per_hour'])
  {
    $message  = $_POST['message'];
    $datetime = $_POST['datetime'];
    $type     = $_POST['type'];
    if(empty($message))
      $tpl->assign('error', $tpl->get_config_vars('err_message'));
    elseif(empty($datetime))
      $tpl->assign('error', $tpl->get_config_vars('err_datetime'));
    else
    {
      //$datetime .= ":00";
      $mins = mysql2timestamp($datetime) - mysql2timestamp(date("Y-m-d H:i:00"));
      // less than 5 minutes between dates ?
      if($mins < 300)
        $tpl->assign('error', $tpl->get_config_vars('err_timelimit'));
      // update database
      else
      {
        $sql = "INSERT INTO tbl0 (`uid`,`message`,`datetime`,`type`,`status`) ".
               "VALUES('{$_SESSION[SESSION_NAME]['uid']}','$message','$datetime','{$type}', 'Q')";

        $db->query($sql,'messages');
        redir('index.php');
      }
    }
    $_POST['datetime'] = date("Y-m-d H:i", time() + (5 * 60));
    $tpl->assign($_POST);
  }
  else
  {
    $tpl->assign('error', $tpl->get_config_vars('err_msglimit'));
    $_POST['datetime'] = date("Y-m-d H:i", time() + (60 * 60));
    $tpl->assign($_POST);
  }
}
else if($a=='edit')
{
  if($_POST['btn_schedule'])
  {
    $mid      = intval($_POST['mid']);
    $message  = $_POST['message'];
    $datetime = $_POST['datetime'];
    $type     = $_POST['type'];
    if(empty($message))
      $tpl->assign('error', $tpl->get_config_vars('err_message'));
    elseif(empty($datetime))
      $tpl->assign('error', $tpl->get_config_vars('err_datetime'));
    else
    {
      $mins = mysql2timestamp($datetime) - mysql2timestamp(date("Y-m-d H:i:00"));
      // less than 5 minutes between dates ?
      if($mins < 300)
        $tpl->assign('error', $tpl->get_config_vars('err_timelimit'));
      // update database
      else
      {
        $sql = "UPDATE tbl0 SET `message`='$message',`datetime`='$datetime',`type`='{$type}' ".
               "WHERE `mid`= '{$mid}' AND `uid`='{$_SESSION[SESSION_NAME]['uid']}'";
        $db->query($sql,'messages');
        redir('index.php');
      }
    }
    $_POST['datetime'] = date("Y-m-d H:i", time() + (5 * 60));
    $tpl->assign($_POST);
  }
  else
  {
    $tpl->assign($db->get_result("SELECT * FROM tbl0 WHERE `mid`='{$_GET['mid']}'", 'messages'));
  }
  //$_POST = $u;
}
else
  $tpl->assign('datetime', date("Y-m-d H:i", time() + (5 * 60)));

$tpl->assign('schedule_options', array(
                       'N' => $tpl->get_config_vars('noreoccurance'),
                       'D' => $tpl->get_config_vars('daily'),
                       'W' => $tpl->get_config_vars('weekly'),
                       'M' => $tpl->get_config_vars('monthly'),
                       'Y' => $tpl->get_config_vars('yearly')
                       ));

$tpl->assign('icons', $icons);
$tpl->assign('a', $a);
$tpl->assign('main_area', 'user.message.tpl');
$tpl->assign('menus', get_menu_items('messages.conf','menu_user','menu_user_admin'));
$tpl->display('user.index.tpl');
?>